package insertCall;

use strict;
use warnings;
use 5.010;
use autodie;

use Time::HiRes qw(gettimeofday);

use base 'Exporter';

our @EXPORT = qw/ insertGenerallog insertCalllog insertCallRequest acceptCallRequest  /;

use DBI;
use Data::Dumper qw(Dumper);
use DBD::mysql;

sub insertGenerallog {

  my $call_id = $_[0];
  my $event = $_[1];
  my $time = gettimeofday;

  my $connection = connectToDB();
  my $sql = "select gemp_name from ant4000_event_maps_points where gemp_ext= ? ";
  my $statement = $connection->prepare($sql);

  $statement->execute($call_id);

  my $call_name = $statement->fetchrow_array();
  $statement->finish();

  if(!$call_name){
    $call_name = "";
  }else{
    $call_name = " | ".$call_name;
  }

  $connection = connectToDB();

  $sql = "INSERT INTO ant4000_general_log ( gl_time, gl_event, gl_src ) VALUES (?,?,?)";
  $statement = $connection -> prepare($sql);
  $statement->execute($time, $event , $call_id  . $call_name);
  $statement->finish();

};

sub insertCalllog {
  my $call_id = $_[0];
  my $call_event = $_[1];
  my $time = gettimeofday;

  my $connection = connectToDB();
  my $sql = "select gemp_name from ant4000_event_maps_points where gemp_ext= ? ";
  my $statement = $connection->prepare($sql);

  $statement->execute($call_id);

  my $call_name = $statement->fetchrow_array();
  $statement->finish();

  if(!$call_name){
    $call_name = "";
  }

  $connection = connectToDB();

  $sql = "INSERT INTO ant4000_call_log ( cl_time, cl_name, cl_src, cl_event ) VALUES ( ?, ?, ?, ? )";
  $statement = $connection->prepare($sql);
  $statement->execute($time, $call_name, $call_id, $call_event);
  $statement->finish();

 return ($connection->{mysql_insertid});;
};

sub insertCallRequest {
  my $clId = $_[0];

  my $connection = connectToDB();

  my $sql = "INSERT INTO ant4000_call_request( cr_cl_id, cr_answer ) VALUES ( ?, ? )";
  my $statement = $connection->prepare($sql);
  $statement->execute($clId, "");
  $statement->finish();

};

sub acceptCallRequest {
  my $call_id = $_[0];

  my $connection = connectToDB();

  my $sql = "delete from ant4000_call_request WHERE ant4000_call_request.cr_cl_id in ( select cl_id from ant4000_call_log where ant4000_call_log.cl_src = ? )";
  my $statement = $connection->prepare($sql);
  $statement->execute($call_id);
  $statement->finish();

};

sub connectToDB {

  my $database = "zphone";
  my $host = "localhost";
  my $userid = "root";
  my $passwd = "metasec";

  my $connectionInfo="dbi:mysql:$database;$host";

  my $l_connection = DBI->connect($connectionInfo,$userid,$passwd);

  return $l_connection;

};

1;
