use strict;
use warnings;
use Device::SerialPort;
use Time::HiRes qw(usleep nanosleep);
use Data::Dumper qw(Dumper);

use lib qw(/var/www/zphone/gehrke/bin);

use DBI;
use DBD::mysql;
use insertCall qw/ insertGenerallog insertCalllog insertCallRequest acceptCallRequest  /;

my $port = Device::SerialPort->new("/dev/ttyUSB0");

sub  trim {
    my $s = shift;
    $s =~ s/^\s+|\s+$//g;
    return $s
};

$port->baudrate(19200);
$port->databits(8);
$port->parity("none");
$port->stopbits(1);
$port->datatype("raw");
$port->read_char_time(0);

print "\nBegin perl serial listener\n" ;

my $str = "";

while (1) {
    my $char = $port->read(1);
    if ( ord($char) != 12

	&& ord($char) != 8
	&& ord($char) != 6
	&& ord($char) != 10
	&& ord($char) != 11
	&& ord($char) != 19

	&& ord($char) != 2
	&& ord($char) != 1 ) {
	    if ( ord($char) == 3 ) {


		$str = trim($str);

		if ( $str ne ""  ) {

        my $sub = substr($str, 0, 2);

        $char = chr(27);
        $str =~ s/$char//g;

        my $char0 = ord(substr($str, 0, 1));
        my $char1 = ord(substr($str, 1, 2));

        if($char0 == 14 && $char1 == 84){
          print("call Request accepted - $str\n");

          my $call_id = substr($str,5);
          $call_id = substr($call_id,0,length($call_id)-7);

          acceptCallRequest($call_id);
          insertGenerallog($call_id, "call-request-accepted");
          insertCalllog($call_id, "call-request-accepted");

        }

        if($char0 == 84 && $char1 == 63){
          print("Call-Request - $str\n");

          my  $call_id = substr($str,4);
          $call_id = substr($call_id,0,length($call_id)-2);

          insertGenerallog($call_id, "call-request");
          my $callogId = insertCalllog($call_id, "call-request");
          insertCallRequest($callogId);
        }

        if (index($str, "D'b" ) != -1) {

          my @tmp  = split(" ", $str);
          my @tmp2 = split("'b", $tmp[0]);

          my $call_id = $tmp2[1];
          my $call_name = $tmp[1];
          $call_name = substr($call_name,0,length($call_name)-2);

          print("CALL-> id: $call_id | name $call_name - $str \n");

          insertGenerallog($call_id, "calllog" );
          insertCalllog($call_id, "call");

        }

		}
		$str = "";

	    } else {

    		$str .= $char;
    		my $last = $char;

	    }
    }

    usleep (1000);
}
